///////////////////////////////////////////////
// Copyright
///////////////////////////////////////////////
//
// Example of the TextFX6 library
// Copyright (c) 2008 Jari Komppa
//
//
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
// 
//
///////////////////////////////////////////////
#include <windows.h>
#include <stdio.h>
#include "textfx.h"
#include "fliflc.h"
#include "conio.h"

void rgb(int *fb, int*fb2, int tick)
{
    int i,j;
    for (i = 0; i < 160; i++)
    {
        for (j = 0; j < 100; j++)
        {
            fb[j * 160 + i] = 
                (((j * 255) / 100) << 0) |
                (((i * 255) / 160) << 8) |
                (((tick >> 4) & 0xff) << 16);
                0;
            fb2[j * 320 + i] = 
                (((j * 255) / 100) << 0) |
                (((i * 255) / 160) << 8) |
                (((tick >> 4) & 0xff) << 16);
                0;

        }
    }
}

int *loadtestimage()
{
    int i, j;
    FILE * f;
    int * fb = new int[160*100];
    f = fopen("TextFX5.bmp","rb");
    fseek(f,-160*100*4,SEEK_END);
    for (i = 0; i < 100; i++)
    {
        for (j = 0; j < 160; j++)
        {
            int data;
            fread(&data,1,4,f);
            data = (((data >> 0) & 0xff) << 0) |
                   (((data >> 16) & 0xff) << 16) |
                   (((data >> 24) & 0xff) << 8);
            fb[(99-i)*160+j] = data;
        }
    }
    fclose(f);
    return fb;
}

int *loadtestimage2()
{
    int i, j;
    FILE * f;
    int * fb = new int[320*200];
//    f = fopen("lena_crop.bmp","rb");
//    f = fopen("curves.bmp","rb");
    f = fopen("colramp.bmp","rb");
//    f = fopen("satramp.bmp","rb");
    fseek(f,-320*200*4,SEEK_END);
    for (i = 0; i < 200; i++)
    {
        for (j = 0; j < 320; j++)
        {
            int data;
            fread(&data,1,4,f);
            data = (((data >> 0) & 0xff) << 0) |
                   (((data >> 16) & 0xff) << 16) |
                   (((data >> 24) & 0xff) << 8);
            fb[(199-i)*320+j] = data;
        }
    }
    fclose(f);
    return fb;
}

void demomain()
{
    TFX_TCConverter * tc = NULL;
    TFX_ColAsciiArt caa;
    TFX_ColAsciiArt2 caa2;
    TFX_AsciiArt aa;
    TFX_AsciiArt2 aa2;
    TFX_HalfBlockColor hbc;
    TFX_HalfBlockColorWide hbcw;
    TFX_BlockColor bc;
    TFX_HalfBlockColorDynamic hbcd;
    TFX_BruteForce bf;

    TFX_SetTitle("Wait, precalculating"); 
    bc.BuildLUT();   
    TFX_SetTitle("Wait, precalculating.");
    aa.BuildLUT();
    TFX_SetTitle("Wait, precalculating..");
    aa2.BuildLUT();
    TFX_SetTitle("Wait, precalculating...");
    caa.BuildLUT();
    TFX_SetTitle("Wait, precalculating....");
    caa2.BuildLUT();

//#define INCLUDE_BRUTEFORCE

#define N_MODES 3
#define N_CONVERTERS 11
#define N_DITHERS 3
#define N_TESTS 3

    FliAnimation *a=new FliAnimation("lodju.flc",0);
    a->renderframe();
    a->renderframe();
    a->renderframe();
    int * pal=new int[256];
    int * fb=new int[160*100];
    int * fb2=new int[320*200];
    for (int i=0;i<256;i++)
        pal[i]=((a->mPalette[i*3+0]&0xff)<<2)+
               ((a->mPalette[i*3+1]&0xff)<<10)+
               ((a->mPalette[i*3+2]&0xff)<<18);
    int *testimage = loadtestimage();
    int *testimage2 = loadtestimage2();
    unsigned int tick=GetTickCount();
    int key = 0;
    int idx = 0;
    char * dither = "none";
    char * converter = "none";
    while(key != 0x1b)
    {
        if (_kbhit()) 
        {
            key = _getch();
            idx++;
        }
        while (tick>=GetTickCount()) {};
        tick+=(1000/25);

        switch ((idx / (N_MODES * N_CONVERTERS * N_DITHERS)) % N_TESTS)
        {
        case 0:
            memcpy(fb,testimage,160*100*4);
            memcpy(fb2,testimage2,320*200*4);
            break;
        case 1:
            a->renderframe();
            for (int i=0;i<100;i++)
            for (int j=0;j<160;j++)
            {
                fb[i*160+j]=pal[a->mFramebuffer[i*160+j]&0xff];
                fb2[i*320+j]=pal[a->mFramebuffer[i*160+j]&0xff];
            }
            break;
        case 2:
            rgb(fb, fb2, tick);
            break;
        }

        switch ((idx / (N_MODES * N_CONVERTERS)) % N_DITHERS)
        {
        case 0:
            dither = "none";
            break;
        case 1:
            TFX_RandomDither(fb, 160, 100);
            dither = "random";
            break;
        case 2:
            TFX_OrderedDither(fb, 160, 100);
            dither = "ordered";
            break;
        }

        switch (idx % N_CONVERTERS)
        {
        case 0:
            tc = &bc;
            converter = "BlockColor";
            break;
        case 1:
            tc = &aa;
            converter = "AsciiArt";
            break;
        case 2:
            tc = &aa2;
            converter = "AsciiArt2";
            break;
        case 3:
            tc = &caa2;
            converter = "ColorAsciiArt2";
            break;
        case 4:
            caa.SetOptions(0xff);
            tc = &caa;
            converter = "ColorAsciiArt";
            break;
        case 5:
            caa.SetOptions(0);            
            tc = &caa;
            converter = "ColorAsciiArt (no dither, no bg)";
            break;
        case 6:
            caa.SetOptions(CAA_USEDITHER);
            tc = &caa;
            converter = "ColorAsciiArt (no bg)";
            break;
        case 7:
            tc = &hbc;
            converter = "HalfBlockColor";
            break;
        case 8:
            tc = &hbcw;
            converter = "HalfBlockColorWide";
            break;
        case 9:
            tc = &hbcd;
            converter = "HalfBlockColorDynamic";
            break;
        case 10:
#ifdef INCLUDE_BRUTEFORCE
            tc = &bf;
            converter = "BruteForce";
#else
            tc = &hbcd;
            idx++;
#endif
            break;
        }

        switch ((idx / N_CONVERTERS) % N_MODES)
        {
        case 0:
            tc->Dump1x(fb,TFXQuad(0,0,80,50),160,0,0);
            break;
        case 1:
            tc->Dump2x(fb,TFXQuad(0,0,160,100),160,0,0);
            break;
        case 2:
            tc->Dump4x(fb2,TFXQuad(0,0,320,200),320,0,0);
            break;
        }

        char temp[256];
        sprintf(temp,"TextFX6 - converter (%d):%s dither:%s - space to cycle",idx,converter,dither);
        TFX_SetTitle(temp);

        TFX_Present();
    }
}