///////////////////////////////////////////////
// Copyright
///////////////////////////////////////////////
//
// FliFlc
// Copyright (c) 2001 Jari Komppa
//
//
///////////////////////////////////////////////
// License
///////////////////////////////////////////////
// 
//     This software is provided 'as-is', without any express or implied
//     warranty.    In no event will the authors be held liable for any damages
//     arising from the use of this software.
// 
//     Permission is granted to anyone to use this software for any purpose,
//     including commercial applications, and to alter it and redistribute it
//     freely, subject to the following restrictions:
// 
//     1. The origin of this software must not be misrepresented; you must not
//        claim that you wrote the original software. If you use this software
//        in a product, an acknowledgment in the product documentation would be
//        appreciated but is not required.
//     2. Altered source versions must be plainly marked as such, and must not be
//        misrepresented as being the original software.
//     3. This notice may not be removed or altered from any source distribution.
// 
// (eg. same as ZLIB license)
// 
//
///////////////////////////////////////////////

#ifndef FLIFLC_H_INCLUDED
#define FLIFLC_H_INCLUDED

class FliAnimation
{
public:
    FliAnimation(char *aFilename, int aOffset);
    ~FliAnimation();
    void renderframe();
    unsigned char * mFramebuffer; // Picture buffer. 
    unsigned char * mPalette;     // Pointer to 768 byte palette buffer.
    int    mPaletteChange; // changes to 1 if palette changes 
    int    mXSize;       // x-size of framebuffer 
    int    mYSize;       // y-size of framebuffer 
    int    mCurframe;    // Current frame 
    int    mMaxframe;    // max. frame 
    int    mLooped;      // changes to 1 if we're looped. 
private:
    unsigned char * mNextframe;   // Pointer to next frame in flicdata 
    unsigned char * mLoopframe;   // Pointer to loop frame in flicdata 
    unsigned char * mFlicdata;    // Pointer to the (raw) fli data. 
    unsigned char * fli_frame();
// chunk handlers
    void fli_black();
    void fli_copy(unsigned char *data);
    void fli_colour(unsigned char *cdata);
    void fli_colour256(unsigned char *cdata);
    void fli_rc(unsigned char*lcdata);
    void fli_ss2(unsigned char*lcdata);
    void fli_brun(unsigned char*brundata);
// chunk analyzer
    unsigned char *decode_chunk(unsigned char *thischunk);
};

#endif //FLIFLC_H_INCLUDED